import "Turbine.Utils";
import "Turbine.Gameplay";
import "FalstarPlugins.Aura";

Aura = class();

function Aura:Constructor()
	
	self.name = "New Aura";
	self.id = math.round(math.random()*1.0e8);
	self.pattern = {"Pattern"};
	self.showTimer = false;
	self.showActive = true;
	self.exactMatch = false;
	self.flashing = false;
	self.curable = false;
	self.background = 1;

	self.my_cat = Turbine.Gameplay.EffectCategory.Undefined;

end

function Aura:Copy(keep_id)

	local copy = Aura();
	copy:SetName(self.name);
	if (keep_id) then
	    copy:SetID(self.id);
	end
	copy:SetShowTimer(self.showTimer);
	copy:SetShowActive(self.showActive);
	copy:SetExactMatch(self.exactMatch);
	copy:SetFlashing(self.flashing);
	copy:SetCurable(self.curable);
	copy:SetBackground(self.background);
	copy:SetCategory(self.my_cat);
	
	local ii;
	local pattern = {};
	for ii = 1, table.getn(self.pattern) do
		pattern[ii] = self.pattern[ii];
	end
	copy:SetPattern(pattern);
	
	return copy;

end

function Aura:GetName()
	return self.name;
end

function Aura:SetName(name)
	self.name = name;
end

function Aura:GetID()
	return self.id;
end

function Aura:SetID(id)
	self.id = id;
end

function Aura:GetPattern()
	return self.pattern;
end

function Aura:GetPatternText(index)
	return self.pattern[index];
end

function Aura:SetPattern(pattern)
	self.pattern = pattern;      	
--	local ii;	
--	for ii = 1, table.getn(pattern) do
--		Turbine.Shell.WriteLine("Set Aura: " .. pattern[ii]);
--	end
end

function Aura:AddPattern(pattern_string)
	table.insert(self.pattern, pattern_string);
end

function Aura:DeletePattern(index)	
	table.remove(self.pattern, index);
end

function Aura:GetNumberOfPatterns()
--	Turbine.Shell.WriteLine(self.pattern);
	return table.getn(self.pattern);
end
              
function Aura:GetShowTimer()
	return self.showTimer;
end

function Aura:SetShowTimer(flag)
	self.showTimer = flag;
end

function Aura:GetShowActive()
	return self.showActive;
end

function Aura:SetShowActive(flag)
	self.showActive = flag;
end

function Aura:GetExactMatch()
	return self.exactMatch;
end

function Aura:SetExactMatch(flag)
	self.exactMatch = flag;
end                  

function Aura:GetFlashing()
	return self.flashing;
end

function Aura:SetFlashing(flag)
	self.flashing = flag;
end

function Aura:GetCurable()
	return self.curable;
end

function Aura:SetCurable(flag)
	self.curable = flag;
end

function Aura:GetBackground()
	return self.background;
end

function Aura:SetBackground(id)
	self.background = id;
end

function Aura:GetCategory()
	return self.my_cat;
end

function Aura:SetCategory(category)

--	if ((Turbine.Gameplay.EffectCategory.Undefined == type) or
--	    (Turbine.Gameplay.EffectCategory.Wound == type) or
--	    (Turbine.Gameplay.EffectCategory.Fear == type) or
--	    (Turbine.Gameplay.EffectCategory.Poison == type) or
--		(Turbine.Gameplay.EffectCategory.Disease == type)) then
		
		self.my_cat = category;

-- 	end

end