import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Utils"; 
import "FalstarPlugins.Aura";

--AuraEffect = class(Turbine.UI.Lotro.EffectDisplay);
AuraEffect = class(Turbine.UI.Control);

function AuraEffect:Constructor()   

	Turbine.UI.Control.Constructor(self);      
	
	self.window_opacity = 0;
	self.flashing = false;
	 
	self.aura = nil;
	self:SetVisible(false);
--	self:SetBackColor(Turbine.UI.Color(0.01, 0, 0, 0));     
    self:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
--	self:SetZOrder(150);
	self:SetMouseVisible(false);

--	self.window = Turbine.UI.Window();
--	self.window:SetParent(self);
		
	self.display = Turbine.UI.Lotro.EffectDisplay();
	self.display:SetParent(self);
	self.display:SetVisible(false); 
	self.display:SetOpacity(0.5);
--	self.display:SetZOrder(50);
	self.display:SetMouseVisible(false);
	
	self.inactive = Turbine.UI.Control();
	self.inactive:SetParent(self);
    self.inactive:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	self.inactive:SetVisible(false);    
--	self.inactive:SetBackColor(Turbine.UI.Color(1, 1, 0, 0)); 
	self.inactive:SetMouseVisible(false);

    self.timer = Turbine.UI.Label();
    self.timer:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
--    self.timer:SetBackColor(Turbine.UI.Color(1, 0, 1, 0));
    self.timer:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0)); 
    self.timer:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);    
--	self.timer:SetZOrder(100);
    self.timer:SetParent(self);
	self.timer:SetMouseVisible(false);
    self.timer:SetVisible(false); 
    self.timer:SetText("asdf");

    self.Update = function(sender, args)  
    
    	if (self.aura:GetShowActive()) then
	    
	--        Turbine.Shell.WriteLine("AuraEffect Update");
			if (self.display ~= nil) then
				if (self.display:GetEffect() ~= nil) then
			
				    local gameTime = Turbine.Engine.GetGameTime();
				    local remTime = self.endTime - gameTime
				    
				    if (self.flashing) then
					    local flash = remTime - math.floor(remTime);
					    flash = 0.5 * math.sin(flash * 2 * 3.14159) + 0.5;
					    local alpha = self.window_opacity * (1 - flash) + 1.0 * flash;
					    self:SetBackColor(Turbine.UI.Color(alpha, flash, 0, 0));
				    end
	
				    if (remTime < 0) then
						remTime = 0.0;
					end
	
				   	self.timer:SetText(math.ceil(remTime));
	
				else
				    self:SetWantsUpdates(false);
				    self.SetVisible(false);
				end
			end
		
		else
		
		end
		
    end       
    	   
end

function AuraEffect:GetWindowOpacity()
	return self.window_opacity;
end

function AuraEffect:SetWindowOpacity(alpha)
	self.window_opacity = alpha;
end

function AuraEffect:IsFlashing()
	return self.flashing;
end

function AuraEffect:SetFlashing(flashing)
	self.flashing = flashing;
end

function AuraEffect:SetAuraSize(width, fontsize)
	
	self.width = width;
	self.height = width + fontsize;
	
--	self.window:SetSize(self.width, self.height);
	                                          
	if (fontsize == 10) then
	    self.timer:SetFont(Turbine.UI.Lotro.Font.Verdana10);   
	elseif (fontsize == 12) then    
	    self.timer:SetFont(Turbine.UI.Lotro.Font.Verdana12);   
	elseif (fontsize == 14) then    
	    self.timer:SetFont(Turbine.UI.Lotro.Font.Verdana14);   
	elseif (fontsize == 16) then    
	    self.timer:SetFont(Turbine.UI.Lotro.Font.Verdana16);   
	elseif (fontsize == 18) then    
	    self.timer:SetFont(Turbine.UI.Lotro.Font.Verdana18);   
	elseif (fontsize == 20) then    
	    self.timer:SetFont(Turbine.UI.Lotro.Font.Verdana20);   
	elseif (fontsize == 22) then    
	    self.timer:SetFont(Turbine.UI.Lotro.Font.Verdana22);
	end
    
	self:SetSize(width, self.height);  
	self.display:SetSize(width, width);
	self.inactive:SetSize(width, width);
	self.timer:SetSize(width, fontsize);  
	  
	self.display:SetPosition(0, fontsize);                    
	self.inactive:SetPosition(0, fontsize);                          
	self.timer:SetPosition(0, 0);
	
end

--function AuraEffect:Dispose()
--	self.display = nil;
--	self.timer = nil;
--end

function AuraEffect:GetAura()
--	Turbine.Shell.WriteLine("get " .. self.aura:GetName());
	return self.aura;
end

function AuraEffect:SetAura(aura)
	self.aura = aura;
	if (self.aura ~= nil) then
--	    if self.aura:GetShowTimer() then
--	    	Turbine.Shell.WriteLine("Set true");
--	    else
--	    	Turbine.Shell.WriteLine("Set false");
--	    end
	    
	    -- only show timer if effect is showActive
	    if (self.aura:GetShowActive()) then
	    	self.display:SetVisible(true);              
			self.timer:SetVisible(self.aura:GetShowTimer());
	    else
	    	self.inactive:SetVisible(true);
	    end
	    	    
	    if (self.aura:GetBackground() == 1) then
	    	self.background = "FalstarPlugins/Aura/Resources/shield_";
	    elseif (self.aura:GetBackground() == 2) then              
	    	self.background = "FalstarPlugins/Aura/Resources/green_";
	    elseif (self.aura:GetBackground() == 3) then              
	    	self.background = "FalstarPlugins/Aura/Resources/down_";
	    elseif (self.aura:GetBackground() == 4) then                  
	    	self.background = "FalstarPlugins/Aura/Resources/sun_";
	    elseif (self.aura:GetBackground() == 5) then                  
	    	self.background = "FalstarPlugins/Aura/Resources/swords_";
	    elseif (self.aura:GetBackground() == 6) then                  
	    	self.background = "FalstarPlugins/Aura/Resources/moon_";
	    elseif (self.aura:GetBackground() == 7) then                  
	    	self.background = "FalstarPlugins/Aura/Resources/star_";
	    elseif (self.aura:GetBackground() == 8) then                  
	    	self.background = "FalstarPlugins/Aura/Resources/paw_";
	    elseif (self.aura:GetBackground() == 9) then                  
	    	self.background = "FalstarPlugins/Aura/Resources/skull_";
	    elseif (self.aura:GetBackground() == 10) then                  
	    	self.background = "FalstarPlugins/Aura/Resources/leaf_";
	    end
--	    Turbine.Shell.WriteLine(self.background .. self.width .. ".tga");	   
	
    	self.inactive:SetBackground(self.background .. self.width .. ".tga");
    	
    	if (self.flashing) then
    		self:SetVisible(true);
		end    
	    
	end
--	Turbine.Shell.WriteLine("set " .. aura:GetName());
end

function AuraEffect:GetEffect()
	return self.dispay:GetEffect();
end
     
function AuraEffect:SetEffect(effect)
        
	if (self.aura:GetShowActive()) then
	
 		self:SetWantsUpdates(true);	
		self.display:SetEffect(effect);
	
	    self.startTime = effect:GetStartTime();
	    self.duration = effect:GetDuration();
	    self.endTime = (self.startTime + self.duration);
	    if (self.duration > 1.0e15) then
	    	self.timer:SetVisible(false);
	    end
--	    Turbine.Shell.WriteLine(self.aura:GetName() .. ": " .. self.startTime .. " : " .. self.duration .. " : " .. self.endTime);
    
    end
	
end

function AuraEffect:GetID()

	local ret = nil;
	if (self.display:GetEffect() ~= nil) then
	    ret = self.display:GetEffect():GetID();
	end
	
	return ret;
	
end
