import "Turbine.UI";
import "Turbine.Utils";
import "Turbine.UI.Lotro";
import "FalstarPlugins.Aura";

DialogBox = class(Turbine.UI.Lotro.Window);

function DialogBox:Constructor()

	Turbine.UI.Lotro.Window.Constructor(self);
	
	self.value = false;

    local displayWidth, displayHeight = Turbine.UI.Display.GetSize();       
    
    self:SetSize(300, 150);
	self:SetPosition((displayWidth - 200.0)/2.0, (displayHeight - 100.0)/2.0);
	self:SetVisible(false);
	self:SetZOrder(100);
	self:SetText("Confirm");

	self.label = Turbine.UI.Label();
	self.label:SetParent(self);
    self.label:SetSize(180, 30);
    self.label:SetPosition(60, 50);
    self.label:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
    self.label:SetForeColor(Turbine.UI.Color(245/255, 222/255, 147/255));
--    self.label:SetText("Do you really want to restore default options?");
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	self.cancelButton = Turbine.UI.Lotro.Button();
    self.cancelButton:SetParent(self);
    self.cancelButton:SetPosition(45, 100);
    self.cancelButton:SetSize(100, 20);
    self.cancelButton:SetText("Cancel");
    self.cancelButton.Click = function(sender, args)
        self.value = false;
        self.ClickCancel();
    end

	self.okButton = Turbine.UI.Lotro.Button();
    self.okButton:SetParent(self);
    self.okButton:SetPosition(155, 100);
    self.okButton:SetSize(100, 20);
    self.okButton:SetText("OK");
    self.okButton.Click = function(sender, args)
        self.value = true;
        self.ClickOK();
    end

    self.ClickCancel = FalstarPlugins.Aura.Event();
    self.ClickOK = FalstarPlugins.Aura.Event();

end

function DialogBox:SetLabelText(text)
	self.label:SetText(text);
end

function DialogBox:SetLabelWidth(width)

	if (width > 300) then
	    width = 300;
	end
	
	self.label:SetSize(width, 30);
	self.label:SetPosition((300.0 - width)/2.0, 50)
end