import "Turbine.UI";  
import "Turbine.UI.Lotro";
import "Turbine.Utils";
import "Turbine.Gameplay";
import "FalstarPlugins.Aura";

LibraryPanel = class(Turbine.UI.Control);

function LibraryPanel:Constructor()

    Turbine.UI.Control.Constructor(self);
    
--    self:SetWantsUpdates(true);
--    self.Update = function(sender, args)
--        self:SyncAura()
--    end

	self:SetSize(436, 605);
--    self:SetBackColor(Turbine.UI.Color(1, 1, 0, 0));

	local yy = 10;
    
    self.auraCombo = ComboBox();
    self.auraCombo:SetParent(self);
    self.auraCombo:SetSize(300, 20);
    self.auraCombo:SetPosition(68, yy);
    self.auraCombo.SelectedIndexChanged = function(sender, args)
    
    	data.aura_index = self.auraCombo:GetSelectionIndex();
    
        self.nameText:SetText(args.selection:GetName());
    	self.showTimerCB:SetChecked(args.selection:GetShowTimer());
    	self.showActiveCB:SetChecked(args.selection:GetShowActive());    
		self.exactMatchCB:SetChecked(args.selection:GetExactMatch());
		self.flashingCB:SetChecked(args.selection:GetFlashing());
		self.curableCB:SetChecked(args.selection:GetCurable());
		self.inactiveCombo:SetSelection(args.selection:GetBackground());	
--    	self.patternText:SetText(args.selection:GetPattern());

        local category = args.selection:GetCategory();
		if (category == Turbine.Gameplay.EffectCategory.Wound) then
	    	self.woundTypeCB:SetChecked(true);
		elseif (category == Turbine.Gameplay.EffectCategory.Fear) then
		    self.fearTypeCB:SetChecked(true);
		elseif (category == Turbine.Gameplay.EffectCategory.Poison) then
	    	self.poisonTypeCB:SetChecked(true);
		elseif (category == Turbine.Gameplay.EffectCategory.Disease) then
	    	self.diseaseTypeCB:SetChecked(true);
		elseif (category == Turbine.Gameplay.EffectCategory.Cry) then
	    	self.cryTypeCB:SetChecked(true);
		elseif (category == Turbine.Gameplay.EffectCategory.Elemental) then
	    	self.elementalTypeCB:SetChecked(true);
		elseif (category == Turbine.Gameplay.EffectCategory.Physical) then
	    	self.physicalTypeCB:SetChecked(true);
		elseif (category == Turbine.Gameplay.EffectCategory.Song) then
	    	self.songTypeCB:SetChecked(true);
		elseif (category == Turbine.Gameplay.EffectCategory.Corruption) then
	    	self.corruptionTypeCB:SetChecked(true);
		else
	    	self.woundTypeCB:SetChecked(false);
		    self.fearTypeCB:SetChecked(false);
	    	self.poisonTypeCB:SetChecked(false);
	    	self.diseaseTypeCB:SetChecked(false);                                               
			self.cryTypeCB:SetChecked(false);
			self.elementalTypeCB:SetChecked(false);
		    self.physicalTypeCB:SetChecked(false);
		    self.songTypeCB:SetChecked(false);
		    self.corruptionTypeCB:SetChecked(false);
		end

		self:UpdatePattern();
		
    end
    
    yy = yy + 30;

    self.newButton  = Turbine.UI.Lotro.Button();
    self.newButton:SetParent(self);
    self.newButton:SetPosition(58, yy);
    self.newButton:SetSize(100, 20);
    self.newButton:SetText("New");
    self.newButton.Click = function(sender, args)
        self:AddNewAura();
    end

    self.copyButton  = Turbine.UI.Lotro.Button();
    self.copyButton:SetParent(self);
    self.copyButton:SetPosition(168, yy);
    self.copyButton:SetSize(100, 20);
    self.copyButton:SetText("Copy");
    self.copyButton.Click = function(sender, args)
        self:CopyAura();
    end

    self.deleteButton  = Turbine.UI.Lotro.Button();
    self.deleteButton:SetParent(self);
    self.deleteButton:SetPosition(278, yy);
    self.deleteButton:SetSize(100, 20);
    self.deleteButton:SetText("Delete");
    self.deleteButton.Click = function(sender, args)
        self:DeleteAura();
    end                            
    
    yy = yy + 60;
                                          
    self.showTimerCB = CheckBox();
    self.showTimerCB:SetParent(self);
    self.showTimerCB:SetText("Show Timer");  
    self.showTimerCB:SetPosition(19, yy);
    self.showTimerCB:SetSize(120, 20);  
    self.showTimerCB.CheckedChanged = function(sender, args)
		self.auraCombo:GetSelection():SetShowTimer(self.showTimerCB:IsChecked());
    end      
                                          
    self.flashingCB = CheckBox();
    self.flashingCB:SetParent(self);
    self.flashingCB:SetText("Flashing");  
    self.flashingCB:SetPosition(158, yy);
    self.flashingCB:SetSize(120, 20);  
    self.flashingCB.CheckedChanged = function(sender, args)
		self.auraCombo:GetSelection():SetFlashing(self.flashingCB:IsChecked());
    end      

    self.exactMatchCB = CheckBox();
    self.exactMatchCB:SetParent(self);
    self.exactMatchCB:SetText("Exact Match");     
    self.exactMatchCB:SetPosition(297, yy);
    self.exactMatchCB:SetSize(120, 20);  
    self.exactMatchCB.CheckedChanged = function(sender, args)
		self.auraCombo:GetSelection():SetExactMatch(self.exactMatchCB:IsChecked());
    end
    
    yy = yy + 30;

    self.showActiveCB = CheckBox();
    self.showActiveCB:SetParent(self);
    self.showActiveCB:SetText("Show When Active");
    self.showActiveCB:SetPosition(13, yy);
    self.showActiveCB:SetSize(200, 20);    
    self.showActiveCB.CheckedChanged = function(sender, args)
    
		self.auraCombo:GetSelection():SetShowActive(self.showActiveCB:IsChecked());
	
		if (self.showActiveCB:IsChecked()) then   
    		self.inactiveCombo:SetEnabled(false);
		else                                
    		self.inactiveCombo:SetEnabled(true);
		end
		
    end           
	    
    self.inactiveCombo = ComboBox();
    self.inactiveCombo:SetParent(self);
    self.inactiveCombo:SetEnabled(false);
    self.inactiveCombo:SetSize(150, 20);
    self.inactiveCombo:SetPosition(270, yy); 	   
	self.inactiveCombo:AddItem("Shield", 1);   
	self.inactiveCombo:AddItem("Green Arrow", 2);   
	self.inactiveCombo:AddItem("Down Arrow", 3);   
	self.inactiveCombo:AddItem("Sun", 4);   
	self.inactiveCombo:AddItem("Swords", 5);   
	self.inactiveCombo:AddItem("Moon", 6);   
	self.inactiveCombo:AddItem("Star", 7);   
	self.inactiveCombo:AddItem("Paw", 8);   
	self.inactiveCombo:AddItem("Skull", 9);   
	self.inactiveCombo:AddItem("Leaf", 10);   
	self.inactiveCombo:SetSelection(1);   
    self.inactiveCombo.SelectedIndexChanged = function(sender, args)
    	self.auraCombo:GetSelection():SetBackground(self.inactiveCombo:GetSelection());
    end
    
    yy = yy + 60;

    self.woundTypeCB = CheckBox();
    self.woundTypeCB:SetParent(self);
    self.woundTypeCB:SetText("Wound");        
    self.woundTypeCB:SetPosition(13, yy);
    self.woundTypeCB:SetSize(200, 20);
    self.woundTypeCB.CheckedChanged = function(sender, args)
		if (self.woundTypeCB:IsChecked()) then
                                            
--			self.woundTypeCB:SetChecked(false);
			self.fearTypeCB:SetChecked(false);
		    self.poisonTypeCB:SetChecked(false);
		    self.diseaseTypeCB:SetChecked(false);                                               
			self.cryTypeCB:SetChecked(false);
			self.elementalTypeCB:SetChecked(false);
		    self.physicalTypeCB:SetChecked(false);
		    self.songTypeCB:SetChecked(false);
		    self.corruptionTypeCB:SetChecked(false);
		    
		    self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Wound);
		                                                      
	    elseif (self:IsCategoryUndefined()) then
	    	self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Undefined);
		end
    end

    self.fearTypeCB = CheckBox();
    self.fearTypeCB:SetParent(self);
    self.fearTypeCB:SetText("Fear");         
    self.fearTypeCB:SetPosition(223, yy);
    self.fearTypeCB:SetSize(200, 20);
    self.fearTypeCB.CheckedChanged = function(sender, args)
		if (self.fearTypeCB:IsChecked()) then
                                            
			self.woundTypeCB:SetChecked(false);
--			self.fearTypeCB:SetChecked(false);
		    self.poisonTypeCB:SetChecked(false);
		    self.diseaseTypeCB:SetChecked(false);                                               
			self.cryTypeCB:SetChecked(false);
			self.elementalTypeCB:SetChecked(false);
		    self.physicalTypeCB:SetChecked(false);
		    self.songTypeCB:SetChecked(false);
		    self.corruptionTypeCB:SetChecked(false);

			self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Fear);
		                                                          
	    elseif (self:IsCategoryUndefined()) then
	    	self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Undefined);
		end
    end
                     
    yy = yy + 30;

    self.poisonTypeCB = CheckBox();
    self.poisonTypeCB:SetParent(self);
    self.poisonTypeCB:SetText("Poison");      
    self.poisonTypeCB:SetPosition(13, yy);
    self.poisonTypeCB:SetSize(200, 20);
    self.poisonTypeCB.CheckedChanged = function(sender, args)
		if (self.poisonTypeCB:IsChecked()) then
                                            
			self.woundTypeCB:SetChecked(false);
			self.fearTypeCB:SetChecked(false);
--		    self.poisonTypeCB:SetChecked(false);
		    self.diseaseTypeCB:SetChecked(false);                                               
			self.cryTypeCB:SetChecked(false);
			self.elementalTypeCB:SetChecked(false);
		    self.physicalTypeCB:SetChecked(false);
		    self.songTypeCB:SetChecked(false);
		    self.corruptionTypeCB:SetChecked(false);

			self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Poison);
			                                                        
	    elseif (self:IsCategoryUndefined()) then
	    	self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Undefined);
		end
    end

    self.diseaseTypeCB = CheckBox();
    self.diseaseTypeCB:SetParent(self);
    self.diseaseTypeCB:SetText("Disease");     
    self.diseaseTypeCB:SetPosition(223, yy);
    self.diseaseTypeCB:SetSize(200, 20);
    self.diseaseTypeCB.CheckedChanged = function(sender, args)
		if (self.diseaseTypeCB:IsChecked()) then
                                            
			self.woundTypeCB:SetChecked(false);
			self.fearTypeCB:SetChecked(false);
		    self.poisonTypeCB:SetChecked(false);
--		    self.diseaseTypeCB:SetChecked(false);                                               
			self.cryTypeCB:SetChecked(false);
			self.elementalTypeCB:SetChecked(false);
		    self.physicalTypeCB:SetChecked(false);
		    self.songTypeCB:SetChecked(false);
		    self.corruptionTypeCB:SetChecked(false);

			self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Disease);
	                                                                  
	    elseif (self:IsCategoryUndefined()) then
	    	self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Undefined);
		end
    end
	             	
    yy = yy + 30;
	
    self.cryTypeCB = CheckBox();
    self.cryTypeCB:SetParent(self);
    self.cryTypeCB:SetText("Cry");     
    self.cryTypeCB:SetPosition(13, yy);
    self.cryTypeCB:SetSize(200, 20);
    self.cryTypeCB.CheckedChanged = function(sender, args)
		if (self.cryTypeCB:IsChecked()) then
                                            
			self.woundTypeCB:SetChecked(false);
			self.fearTypeCB:SetChecked(false);
		    self.poisonTypeCB:SetChecked(false);
		    self.diseaseTypeCB:SetChecked(false);                                               
--			self.cryTypeCB:SetChecked(false);
			self.elementalTypeCB:SetChecked(false);
		    self.physicalTypeCB:SetChecked(false);
		    self.songTypeCB:SetChecked(false);
		    self.corruptionTypeCB:SetChecked(false);

			self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Cry);
	                                                                  
	    elseif (self:IsCategoryUndefined()) then
	    	self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Undefined);
		end
    end
	
    self.elementalTypeCB = CheckBox();
    self.elementalTypeCB:SetParent(self);
    self.elementalTypeCB:SetText("Elemental");     
    self.elementalTypeCB:SetPosition(223, yy);
    self.elementalTypeCB:SetSize(200, 20);
    self.elementalTypeCB.CheckedChanged = function(sender, args)
		if (self.elementalTypeCB:IsChecked()) then
                                            
			self.woundTypeCB:SetChecked(false);
			self.fearTypeCB:SetChecked(false);
		    self.poisonTypeCB:SetChecked(false);
		    self.diseaseTypeCB:SetChecked(false);                                               
			self.cryTypeCB:SetChecked(false);
--			self.elementalTypeCB:SetChecked(false);
		    self.physicalTypeCB:SetChecked(false);
		    self.songTypeCB:SetChecked(false);
		    self.corruptionTypeCB:SetChecked(false);

			self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Elemental);
	                                                                     
	    elseif (self:IsCategoryUndefined()) then
	    	self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Undefined);
		end
    end
	
    yy = yy + 30;
	
    self.physicalTypeCB = CheckBox();
    self.physicalTypeCB:SetParent(self);
    self.physicalTypeCB:SetText("Physical");     
    self.physicalTypeCB:SetPosition(13, yy);
    self.physicalTypeCB:SetSize(200, 20);
    self.physicalTypeCB.CheckedChanged = function(sender, args)
		if (self.physicalTypeCB:IsChecked()) then
                                            
			self.woundTypeCB:SetChecked(false);
			self.fearTypeCB:SetChecked(false);
		    self.poisonTypeCB:SetChecked(false);
		    self.diseaseTypeCB:SetChecked(false);                                               
			self.cryTypeCB:SetChecked(false);
			self.elementalTypeCB:SetChecked(false);
--		    self.physicalTypeCB:SetChecked(false);
		    self.songTypeCB:SetChecked(false);
		    self.corruptionTypeCB:SetChecked(false);

			self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Physical);
	                                                                                             
	    elseif (self:IsCategoryUndefined()) then
	    	self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Undefined);
		end
    end
	
    self.songTypeCB = CheckBox();
    self.songTypeCB:SetParent(self);
    self.songTypeCB:SetText("Song");     
    self.songTypeCB:SetPosition(223, yy);
    self.songTypeCB:SetSize(200, 20);
    self.songTypeCB.CheckedChanged = function(sender, args)
		if (self.songTypeCB:IsChecked()) then
                                            
			self.woundTypeCB:SetChecked(false);
			self.fearTypeCB:SetChecked(false);
		    self.poisonTypeCB:SetChecked(false);
		    self.diseaseTypeCB:SetChecked(false);                                               
			self.cryTypeCB:SetChecked(false);
			self.elementalTypeCB:SetChecked(false);
		    self.physicalTypeCB:SetChecked(false);
--		    self.songTypeCB:SetChecked(false);
		    self.corruptionTypeCB:SetChecked(false);

			self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Song);  
	    
	    elseif (self:IsCategoryUndefined()) then
	    	self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Undefined);	    
		end
    end
    
    yy = yy + 30;
	
    self.curableCB = CheckBox();
    self.curableCB:SetParent(self);
--    self.curableCB:SetEnabled(false);
    self.curableCB:SetText("Curable");     
    self.curableCB:SetPosition(13, yy);
    self.curableCB:SetSize(200, 20);
    self.curableCB.CheckedChanged = function(sender, args)                                              
		self.auraCombo:GetSelection():SetCurable(self.curableCB:IsChecked());
    end
	
    self.corruptionTypeCB = CheckBox();
    self.corruptionTypeCB:SetParent(self);
    self.corruptionTypeCB:SetText("Corruption");     
    self.corruptionTypeCB:SetPosition(223, yy);
    self.corruptionTypeCB:SetSize(200, 20);
    self.corruptionTypeCB.CheckedChanged = function(sender, args)
		if (self.corruptionTypeCB:IsChecked()) then
                                            
			self.woundTypeCB:SetChecked(false);
			self.fearTypeCB:SetChecked(false);
		    self.poisonTypeCB:SetChecked(false);
		    self.diseaseTypeCB:SetChecked(false);                                               
			self.cryTypeCB:SetChecked(false);
			self.elementalTypeCB:SetChecked(false);
		    self.physicalTypeCB:SetChecked(false);
		    self.songTypeCB:SetChecked(false);
--		    self.corruptionTypeCB:SetChecked(false);

			self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Corruption);
	    
	    elseif (self:IsCategoryUndefined()) then
	    	self.auraCombo:GetSelection():SetCategory(Turbine.Gameplay.EffectCategory.Undefined);
		end
    end          
	                    
    yy = yy + 60;
	
	self.nameLabel = Turbine.UI.Label();
	self.nameLabel:SetParent(self);
    self.nameLabel:SetSize(100, 20);
    self.nameLabel:SetPosition(0, yy); 
    self.nameLabel:SetFont(font);
    self.nameLabel:SetForeColor(foreColor);
    self.nameLabel:SetText("Name:");         
--    self.nameLabel:SetBackColor(Turbine.UI.Color(1, 1, 0, 0));
    self.nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	
	self.nameText = Turbine.UI.Lotro.TextBox();
    self.nameText:SetParent(self);
    self.nameText:SetSize(250, 20);
    self.nameText:SetPosition(110, yy);
    self.nameText:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    self.nameText:SetMultiline(false);
    self.nameText:SetWantsUpdates(true)
    self.nameText.Update = function(sender, args)
        if (self.auraCombo:GetSelection() ~= nil) then
			self.auraCombo:UpdateSelectionText(self.nameText:GetText());
			self.auraCombo:GetSelection():SetName(self.nameText:GetText());
		end
	end
	
    yy = yy + 30;

	self.patternLabel = Turbine.UI.Label();
	self.patternLabel:SetParent(self);
    self.patternLabel:SetSize(100, 20);
    self.patternLabel:SetPosition(0, yy);       
    self.patternLabel:SetFont(font);
    self.patternLabel:SetForeColor(foreColor);
    self.patternLabel:SetText("Pattern:");
    self.patternLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
			
	self.addButton = Turbine.UI.Lotro.Button();   
    self.addButton:SetParent(self);
    self.addButton:SetPosition(110, yy);
    self.addButton:SetSize(60, 20);
    self.addButton:SetText("Add");
	self.addButton.Click = function(sender, args)
		self:AddPattern();
	end

    self:UpdateAuraCombo();
    
end

function LibraryPanel:IsCategoryUndefined()
    	
	local ret = true;
	
	if (self.woundTypeCB:IsChecked() or
		self.fearTypeCB:IsChecked() or
		self.poisonTypeCB:IsChecked() or
		self.diseaseTypeCB:IsChecked() or                                            
		self.cryTypeCB:IsChecked() or
		self.elementalTypeCB:IsChecked() or
		self.physicalTypeCB:IsChecked() or
		self.songTypeCB:IsChecked() or
		self.corruptionTypeCB:IsChecked()) then
		ret = false;		
	end
	
	return ret;

end

function LibraryPanel:AddNewAura()

    local aura = Aura();
--    table.insert(data.auraTable, aura);
    self.auraCombo:AddItem(aura:GetName(), aura);
    
    self:EnableControls(true);
    self.auraCombo:SetSelection(aura);

end

function LibraryPanel:CopyAura()

	local current = self.auraCombo:GetSelection();
	local keep_id = false;
    local copy = current:Copy(keep_id);
    copy:SetName(copy:GetName() .. " - Copy");
    
    self.auraCombo:AddItem(copy:GetName(), copy);
    self.auraCombo:SetSelection(copy);

end

function LibraryPanel:DeleteAura()

	local current= self.auraCombo:GetSelection();

	local index = self.auraCombo:GetSelectionIndex();
	if (index == self.auraCombo:GetItemCount()) then
	    index = index - 1;
	end
	
	self.auraCombo:RemoveItem(current);
	
	if (self.auraCombo:GetItemCount() > 0) then
		self.auraCombo:SetSelectionIndex(index);
	else
		self:EnableControls(false);
	end

end

function LibraryPanel:EnableControls(flag)

    self.showTimerCB:SetEnabled(flag);
	self.showActiveCB:SetEnabled(flag);
    self.exactMatchCB:SetEnabled(flag);
    
	if (flag and not self.showActiveCB:IsChecked()) then   
    	self.inactiveCombo:SetEnabled(true);
   	else                                           
    	self.inactiveCombo:SetEnabled(false);
	end
		

	self.woundTypeCB:SetEnabled(flag);
	self.fearTypeCB:SetEnabled(flag);
    self.poisonTypeCB:SetEnabled(flag);
    self.diseaseTypeCB:SetEnabled(flag);
	self.cryTypeCB:SetEnabled(flag);
	self.elementalTypeCB:SetEnabled(flag);
    self.physicalTypeCB:SetEnabled(flag);
    self.songTypeCB:SetEnabled(flag);
    self.corruptionTypeCB:SetEnabled(flag);

	self.nameText:SetEnabled(flag);
    self.addButton:SetEnabled(flag);
	
	local nPattern = 0;
	if (self.patternText ~= nil) then
	    nPattern = table.getn(self.patternText);
	end
	
	for ii = 1, nPattern do
    	self.patternText[ii]:SetEnabled(flag);
    	self.patternButton[ii]:SetEnabled(flag);
    end

end

--function LibraryPanel:CopyAuraTable()
--
--    -- Create a local copy of data.auraTable()
--    self.auraTable = {};
--    local ii;
--    for ii = 1, table.getn(data.auraTable) do
--    	self.auraTable[ii] = data.auraTable[ii]:Copy(true);
--    end
--
--	self:UpdateAuraCombo();
--	
--end

function LibraryPanel:SyncPattern()

--	Turbine.Shell.WriteLine("Sync Pattern");

	local pattern = {};
	local ii;
	if (self.patternText ~= nil) then
		for ii = 1, table.getn(self.patternText) do
			pattern[ii] = self.patternText[ii]:GetText();
		end
		if (self.auraCombo:GetSelection() ~= nil) then
			self.auraCombo:GetSelection():SetPattern(pattern);
		end
	end

end

function LibraryPanel:UpdateAuraCombo()

	if (self.auraCombo.listBox ~= nil) then
	    local nn = self.auraCombo.listBox:GetItemCount();
	    for ii = 1, nn do
			self.auraCombo.listBox:RemoveItemAt(nn + 1 - ii);
		end
	end

    local iaura, aura;
    for iaura = 1, table.getn(data.auraTable) do
    	aura = data.auraTable[iaura]:Copy(true);
		self.auraCombo:AddItem(aura:GetName(), aura);
	end
	
--	Turbine.Shell.WriteLine("aura_index: " .. data.aura_index);
	    
	-- trigger selection update event
	if (data.aura_index == nil) then
		data.aura_index = 1;
	end
	
	if (self.auraCombo:GetItemCount() > 0) then
	    self:EnableControls(true);
		self.auraCombo:SetSelectionIndex(data.aura_index);
	else
	    self:EnableControls(false);
	end
	
end

function LibraryPanel:UpdatePattern()

	-- Clear existing pattern controls	
	if (self.patternText ~= nil) then
		for ii = 1, table.getn(self.patternText) do
			self.patternText[ii]:SetParent(nil);
		end
	end
	self.patternText = {};
	
	if (self.patternButton ~= nil) then
		for ii = 1, table.getn(self.patternButton) do
			self.patternButton[ii]:SetParent(nil);
		end
	end
	self.patternButton = {};     

	local yy = 400;
	aura = self.auraCombo:GetSelection();
	for ii = 1, aura:GetNumberOfPatterns() do
		
		self.patternText[ii] = Turbine.UI.Lotro.TextBox();
	    self.patternText[ii]:SetParent(self);
	    self.patternText[ii]:SetSize(250, 20);
	    self.patternText[ii]:SetPosition(110, yy);
	    self.patternText[ii]:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	    self.patternText[ii]:SetMultiline(false);
	    self.patternText[ii]:SetText(aura:GetPatternText(ii));	    
	    self.patternText[ii]:SetWantsUpdates(true);
	    self.patternText[ii].Update = function(sender, args)
	        self:SyncPattern();
	    end
		
		self.patternButton[ii] = Turbine.UI.Lotro.Button();   
	    self.patternButton[ii]:SetParent(self);
	    self.patternButton[ii]:SetPosition(370, yy);
	    self.patternButton[ii]:SetSize(60, 20);
	    self.patternButton[ii]:SetText("Delete");
		self.patternButton[ii].Click = function(sender, args)
		    self:DeletePattern(ii);
		end                     	
		
		yy = yy + 30;

    end 

	if (self.patternButton[1] ~= nil) then
		self.patternButton[1]:SetVisible(false);
	end
	
--	Turbine.Shell.WriteLine("yy: " .. yy);
                             
    self.addButton:SetPosition(110, yy);
    
end

function LibraryPanel:AddPattern()

	if (self.auraCombo:GetSelection() ~= nil) then
		self.auraCombo:GetSelection():AddPattern("New Pattern");
		self:UpdatePattern();
	end
	
end

function LibraryPanel:DeletePattern(button_id)

	local aura = self.auraCombo:GetSelection():DeletePattern(button_id);
	self:UpdatePattern();
	
end
