import "Turbine.UI";
import "Turbine.UI.Lotro";
import "FalstarPlugins.Aura";


math.randomseed(Turbine.Engine.GetLocalTime());    
    
font = Turbine.UI.Lotro.Font.TrajanPro14;
foreColor = Turbine.UI.Color(245/255, 222/255, 147/255);   

data = Settings();
--Turbine.Shell.WriteLine("Settings Loaded ... ");

function ShowAuraWindow()

	local ii;
	if (auraWindow ~= nil) then
		for ii = 1, table.getn(auraWindow) do
			if (auraWindow[ii] ~= nil) then
			    auraWindow[ii]:Close();
			    auraWindow[ii] = nil;
			end
		end
	end
	auraWindow = {};

	for ii = 1, table.getn(data.windowTable) do
	    if (data.windowTable[ii]:GetShowWindow()) then
--	        Turbine.Shell.WriteLine("Creating window " .. ii);
			auraWindow[ii] = AuraWindow(ii);
		end
	end
	
end

-- show options
function ShowOptions()
    if (optionsWindow == nil) then
        optionsWindow = OptionsWindow();
    end
end

-- show library
function ShowLibrary()
    if (libraryWindow == nil) then
        libraryWindow = LibraryWindow();
    end
end

-- plugin unload event
Turbine.Plugin.Unload = function(self, sender, args)      

	Turbine.Shell.WriteLine("Unload Event ... ");
	
    data:Save();
    
	auraWindow = nil;
	data = nil;
	
end  

-- commands
auraCommand = Turbine.ShellCommand();
Turbine.Shell.AddCommand("aura", auraCommand);
function auraCommand:GetShortHelp()
    return "usage: /aura options | library";
end
function auraCommand:Execute(cmd, args)
    if (args == "options") then
        ShowOptions();
    elseif (args == "library") then
        ShowLibrary();
    else
        Turbine.Shell.WriteLine(self:GetShortHelp());
    end
end

ShowAuraWindow();

Turbine.Shell.WriteLine("Aura 1.0.1");