import "Turbine.UI";  
import "Turbine.UI.Lotro";
import "Turbine.Utils";
import "FalstarPlugins.Aura";

OptionsPanel = class(Turbine.UI.Control);

function OptionsPanel:Constructor()

    Turbine.UI.Control.Constructor(self);

	self:SetSize(436, 605);
--    self:SetBackColor(Turbine.UI.Color(0.2, 1, 0, 0));

	self.windowCombo = ComboBox();
    self.windowCombo:SetParent(self);
    self.windowCombo:SetSize(300, 20);
    self.windowCombo:SetPosition(68, 10);
    self.windowCombo.SelectedIndexChanged = function(sender, args)
    
        data.window_index = self.windowCombo:GetSelectionIndex();
    
--    	Turbine.Shell.WriteLine("windowCombo SelectionIndexChanged");
                                        
        self.nameText:SetText(args.selection:GetName());
        
		self.contextMenuCB:SetChecked(args.selection:GetShowContextMenu());
		self.showWindowCB:SetChecked(args.selection:GetShowWindow());
        
	    self.rowSlider:SetValue(args.selection:GetNumberOfRows());
	    self.colSlider:SetValue(args.selection:GetNumberOfColumns());
	    self.sizeSlider:SetValue(args.selection:GetAuraSize());
	    self.paddingSlider:SetValue(args.selection:GetPadding());
	    self.backSlider:SetValue(math.round(args.selection:GetBackgroundOpacity()*100.0));
	    
	    self:Layout();
    
    end

    self.newButton  = Turbine.UI.Lotro.Button();
    self.newButton:SetParent(self);
    self.newButton:SetPosition(58, 40);
    self.newButton:SetSize(100, 20);
    self.newButton:SetText("New");
    self.newButton.Click = function(sender, args)
        self:AddNewWindow();
    end

    self.copyButton  = Turbine.UI.Lotro.Button();
    self.copyButton:SetParent(self);
    self.copyButton:SetPosition(168, 40);
    self.copyButton:SetSize(100, 20);
    self.copyButton:SetText("Copy");
    self.copyButton.Click = function(sender, args)
        self:CopyWindow();
    end

    self.deleteButton  = Turbine.UI.Lotro.Button();
    self.deleteButton:SetParent(self);
    self.deleteButton:SetPosition(278, 40);
    self.deleteButton:SetSize(100, 20);
    self.deleteButton:SetText("Delete");
    self.deleteButton.Click = function(sender, args)
        self:DeleteWindow();
    end

	self.nameLabel = Turbine.UI.Label();
	self.nameLabel:SetParent(self);
    self.nameLabel:SetSize(100, 20);
    self.nameLabel:SetPosition(0, 70);
    self.nameLabel:SetFont(font);
    self.nameLabel:SetForeColor(foreColor);
    self.nameLabel:SetText("Name:");
--    self.nameLabel:SetBackColor(Turbine.UI.Color(1, 1, 0, 0));
    self.nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);

	self.nameText = Turbine.UI.Lotro.TextBox();
    self.nameText:SetParent(self);
    self.nameText:SetSize(250, 20);
    self.nameText:SetPosition(110, 70);
    self.nameText:SetFont(font);
    self.nameText:SetMultiline(false);
    self.nameText:SetWantsUpdates(true)
    self.nameText.Update = function(sender, args)
    	local text = self.nameText:GetText();
    	if (text ~= nil) then
			self.windowCombo:UpdateSelectionText(self.nameText:GetText());
			
			if (self.windowCombo:GetSelection() ~= nil) then
				self.windowCombo:GetSelection():SetName(self.nameText:GetText());   
			end
		end
	end

    self.showWindowCB = CheckBox();
    self.showWindowCB:SetParent(self);
    self.showWindowCB:SetText("Enable Window");
    self.showWindowCB:SetPosition(13, 100);
    self.showWindowCB:SetSize(200, 20);
    self.showWindowCB.CheckedChanged = function(sender, args)
		self.windowCombo:GetSelection():SetShowWindow(self.showWindowCB:IsChecked());
    end

    self.contextMenuCB = CheckBox();
    self.contextMenuCB:SetParent(self);
    self.contextMenuCB:SetText("Show Context Menu");
    self.contextMenuCB:SetPosition(223, 100);
    self.contextMenuCB:SetSize(200, 20);
    self.contextMenuCB.CheckedChanged = function(sender, args)
    	self.windowCombo:GetSelection():SetShowContextMenu(self.contextMenuCB:IsChecked());
    end

    self.rowSlider = Slider();
    self.rowSlider:SetParent(self);
    self.rowSlider:SetText("Number of Rows");
    self.rowSlider:SetPosition(32, 150);
    self.rowSlider:SetSize(372, 40);
    self.rowSlider:SetStep(1);
    self.rowSlider:SetMin(1);
    self.rowSlider:SetMax(10);
    self.rowSlider.ValueChanged = function(sender, args)
		self.windowCombo:GetSelection():SetNumberOfRows(self.rowSlider:GetValue());
		self:Layout();
    end

    self.colSlider = Slider();
    self.colSlider:SetParent(self);
    self.colSlider:SetText("Number of Columns");
    self.colSlider:SetPosition(32, 200);
    self.colSlider:SetSize(372, 40);
    self.colSlider:SetStep(1);
    self.colSlider:SetMin(1);
    self.colSlider:SetMax(10);
    self.colSlider.ValueChanged = function(sender, args)
		self.windowCombo:GetSelection():SetNumberOfColumns(self.colSlider:GetValue());
		self:Layout();
    end

    self.sizeSlider = Slider();
    self.sizeSlider:SetParent(self);
    self.sizeSlider:SetText("Size");
    self.sizeSlider:SetPosition(32, 250);
    self.sizeSlider:SetSize(372, 40);
    self.sizeSlider:SetStep(8);    
    self.sizeSlider:SetMin(16);
    self.sizeSlider:SetMax(64);
    self.sizeSlider.ValueChanged = function(sender, args)
		self.windowCombo:GetSelection():SetAuraSize(self.sizeSlider:GetValue());
    end

    self.paddingSlider = Slider();
    self.paddingSlider:SetParent(self);
    self.paddingSlider:SetText("Padding");
    self.paddingSlider:SetPosition(32, 300);
    self.paddingSlider:SetSize(372, 40);
    self.paddingSlider:SetStep(1);   
    self.paddingSlider:SetMin(1);
    self.paddingSlider:SetMax(20);
    self.paddingSlider.ValueChanged = function(sender, args)
		self.windowCombo:GetSelection():SetPadding(self.paddingSlider:GetValue());
    end

    self.backSlider = Slider();
    self.backSlider:SetParent(self);
    self.backSlider:SetText("Background Opacity");
    self.backSlider:SetPosition(32, 350);
    self.backSlider:SetSize(372, 40);
    self.backSlider:SetStep(1); 
    self.backSlider:SetMin(0);
    self.backSlider:SetMax(100);
    self.backSlider.ValueChanged = function(sender, args)
		self.windowCombo:GetSelection():SetBackgroundOpacity(self.backSlider:GetValue()/100.0);
    end
    
    self:UpdateWindowCombo();
    
end                      

function OptionsPanel:AddNewWindow()

    local window = WindowSettings();
--    table.insert(data.auraTable, aura);
    self.windowCombo:AddItem(window:GetName(), window);

    self:EnableControls(true);
    self.windowCombo:SetSelection(window);

end

function OptionsPanel:CopyWindow()

	local current = self.windowCombo:GetSelection();
    local copy = current:Copy();
    copy:SetName(copy:GetName() .. " - Copy");
    
    self.windowCombo:AddItem(copy:GetName(), copy);
    self.windowCombo:SetSelection(copy);

end

function OptionsPanel:DeleteWindow()

	local current = self.windowCombo:GetSelection();

	local index = self.windowCombo:GetSelectionIndex();
	if (index == self.windowCombo:GetItemCount()) then
	    index = index - 1;
	end
	
	self.windowCombo:RemoveItem(current);

	if (self.windowCombo:GetItemCount() > 0) then
		self.windowCombo:SetSelectionIndex(index);
	else
		self:EnableControls(false);
	end

end

function OptionsPanel:EnableControls(flag)

    self.nameText:SetEnabled(flag);

	self.contextMenuCB:SetEnabled(flag);
	self.showWindowCB:SetEnabled(flag);

    self.rowSlider:SetEnabled(flag);
    self.colSlider:SetEnabled(flag);
    self.sizeSlider:SetEnabled(flag);
    self.paddingSlider:SetEnabled(flag);
    self.backSlider:SetEnabled(flag);

	local nCombo = 0;
	if (self.comboList ~= nil) then
	    nCombo = table.getn(self.comboList);
	end

	for ii = 1, nCombo do
    	self.comboList[ii]:SetEnabled(flag);
    end

end

function OptionsPanel:UpdateWindowCombo()

	if (self.windowCombo.listBox ~= nil) then
	    local nn = self.windowCombo.listBox:GetItemCount();
	    for ii = 1, nn do
			self.windowCombo.listBox:RemoveItemAt(nn + 1 - ii);
		end
	end

    local iwindow, window;
    for iwindow = 1, table.getn(data.windowTable) do
    	window = data.windowTable[iwindow]:Copy();
    	self.windowCombo:AddItem(window:GetName(), window);
	end

	-- trigger selection update event
	if (data.window_index == nil) then
		data.window_index = 1;
	end

	if (self.windowCombo:GetItemCount() > 0) then
----	    Turbine.Shell.WriteLine("Enable true");
	    self:EnableControls(true);
		self.windowCombo:SetSelectionIndex(data.window_index);
	else
--	    Turbine.Shell.WriteLine("Enable false");
	    self:EnableControls(false);
	end

end

function OptionsPanel:Layout()

	local nlist = self.rowSlider:GetValue() * self.colSlider:GetValue();
	
	local ii;
	if (self.labelList ~= nil) then
		for ii = 1, table.getn(self.labelList) do
			self.labelList[ii]:SetVisible(false);
		    self.labelList[ii] = nil;
		end
	end
	if (self.comboList ~= nil) then
		for ii = 1, table.getn(self.comboList) do
			self.comboList[ii]:SetVisible(false);
		    self.comboList[ii] = nil;
		end
	end
	
	self.labelList = {};
	self.comboList = {};
	
	local aura, iaura, naura;
	naura = table.getn(data.auraTable);
	
	local top = 400;
 	for ii = 1, nlist do

		self.labelList[ii] = Turbine.UI.Label();
		self.labelList[ii]:SetParent(self);
		self.labelList[ii]:SetSize(100, 20);
    	self.labelList[ii]:SetFont(font);
    	self.labelList[ii]:SetForeColor(foreColor);
		self.labelList[ii]:SetPosition(25, top);
		self.labelList[ii]:SetText("Slot " .. ii .. ":");
		self.labelList[ii]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

		self.comboList[ii] = ComboBox();
		self.comboList[ii]:SetParent(self);
		self.comboList[ii]:SetSize(300, 20);
		self.comboList[ii]:SetPosition(110, top);
	    for iaura = 1, naura do
	    	aura = data.auraTable[iaura];
			self.comboList[ii]:AddItem(aura:GetName(), aura);
		end
		self.comboList[ii]:AddItem("Empty", nil);
	    self.comboList[ii].SelectedIndexChanged = function(sender, args)  
	    	self:UpdateAuraMap(ii);	    
	    end

		top = top + 30;

	end
	            
	local auraMap = self.windowCombo:GetSelection():GetAuraMap();
	for ii = 1, nlist do
		
		if (auraMap[ii] == nil) then
			-- set combo to empty
			self.comboList[ii]:SetSelection(self.comboList[ii]:GetItem(self.comboList[ii]:GetItemCount()));
		else
			self.comboList[ii]:SetSelection(self.windowCombo:GetSelection():FindAura(ii));
		end
		
	end
	
	self:SetSize(436, top+200);

end

function OptionsPanel:UpdateAuraMap(index)

--	Turbine.Shell.WriteLine("Update Aura Map");	
	local auraMap = self.windowCombo:GetSelection():GetAuraMap();
	local aura = self.comboList[index]:GetSelection();
	if (aura ~= nil) then
		auraMap[index] = aura:GetID();
	else
		auraMap[index] = nil;
	end
	
end