import "Turbine.UI";  
import "Turbine.UI.Lotro";
import "Turbine.Utils";
import "FalstarPlugins.Aura";

OptionsWindow = class(Turbine.UI.Lotro.Window);

function OptionsWindow:Constructor()

    Turbine.UI.Lotro.Window.Constructor(self);  
        
	local displayWidth, displayHeight = Turbine.UI.Display.GetSize();           
	self:SetPosition(math.round(data.options_left*displayWidth), math.round(data.options_top*displayHeight));    
    self:SetText("Aura Options");
    self:SetVisible(true);
    self:SetSize(500, 700);
--    self:SetZOrder(101);

	self.dialogBox = DialogBox();
    self.dialogBox:SetLabelText("Do you really want to restore default options?");
    self.dialogBox:SetLabelWidth(180);
--	self.dialogBox:SetParent(self);

    self.cancelButton = Turbine.UI.Lotro.Button();
    self.cancelButton:SetParent(self);
    self.cancelButton:SetPosition(90, 665);
    self.cancelButton:SetSize(100, 20);
    self.cancelButton:SetText("Cancel");
    self.cancelButton.Click = function(sender, args)
        self:Close();
    end

    self.resetButton = Turbine.UI.Lotro.Button();
    self.resetButton:SetParent(self);
    self.resetButton:SetPosition(200, 665);
    self.resetButton:SetSize(100, 20);
    self.resetButton:SetText("Defaults");
    self.resetButton.Click = function(sender, args)
		self.dialogBox:SetVisible(true);
    end

    self.dialogBox.ClickCancel = function(sender, args)
--    	Turbine.Shell.WriteLine("Clicked Cancel");
		self.dialogBox:SetVisible(false);
    end

    self.dialogBox.ClickOK = function(sender, args)
--    	Turbine.Shell.WriteLine("Clicked OK");
		data:SetOptions();
		self.optionsPanel:UpdateWindowCombo();
		self.dialogBox:SetVisible(false);
    end

    self.saveButton  = Turbine.UI.Lotro.Button();
    self.saveButton:SetParent(self);
    self.saveButton:SetPosition(310, 665);
    self.saveButton:SetSize(100, 20);
    self.saveButton:SetText("Save");
    self.saveButton.Click = function(sender, args)
        data:Save();
        self:Close();
--        self.optionsPanel:Update();
    end

    self.scrollBar = Turbine.UI.Lotro.ScrollBar();
    self.scrollBar:SetOrientation(Turbine.UI.Orientation.Vertical);
    self.scrollBar:SetParent(self);
    self.scrollBar:SetSize(10, 605);
    self.scrollBar:SetPosition(468, 48);    

    self.containerListBox = Turbine.UI.ListBox();
    self.containerListBox:SetParent(self);
    self.containerListBox:SetOrientation(Turbine.UI.Orientation.Horizontal);
    self.containerListBox:SetVerticalScrollBar(self.scrollBar);
    self.containerListBox:SetSize(436, 605);
    self.containerListBox:SetPosition(32, 48);
    
    self.optionsPanel = OptionsPanel();
    
	self.containerListBox:AddItem(self.optionsPanel);
           
    self.Closed = function(sender, args)
		data:SavePosition();
        ShowAuraWindow();
		optionsWindow = nil;
    end
    
end
