import "Turbine.Utils";
import "FalstarPlugins.Aura";

WindowSettings = class();

function WindowSettings:Constructor()

	self.name = "New Window";

	self.left = 0.5;
	self.top = 0.5;

	self.nrow = 1;
	self.ncol = 6;
	self.padding = 5;
	self.size = 24;
	self.opacity = 0.5;
	self.menu = true;
	self.visible = true;

	self.auraMap = {};
	
end

function WindowSettings:GetName()
	return self.name;
end

function WindowSettings:SetName(name)
	self.name = name;
end

function WindowSettings:GetLeft()
	return self.left;
end

function WindowSettings:SetLeft(left)
	self.left = left;
end

function WindowSettings:GetTop()
	return self.top;
end

function WindowSettings:SetTop(top)
	self.top = top;
end

function WindowSettings:GetNumberOfRows()
	return self.nrow;
end

function WindowSettings:SetNumberOfRows(nrow)
	self.nrow = nrow;
end

function WindowSettings:GetNumberOfColumns()
	return self.ncol;
end

function WindowSettings:SetNumberOfColumns(ncol)
	self.ncol = ncol;
end

function WindowSettings:GetPadding()
	return self.padding;
end

function WindowSettings:SetPadding(padding)
	self.padding = padding;
end

function WindowSettings:GetAuraSize()
	return self.size;
end

function WindowSettings:SetAuraSize(size)
	self.size = size;
end

function WindowSettings:GetBackgroundOpacity()
	return self.opacity;
end

function WindowSettings:SetBackgroundOpacity(opacity)
	self.opacity = opacity;
end                 

function WindowSettings:GetAuraMap()
	return self.auraMap;
end

function WindowSettings:SetAuraMap(auraMap)
	self.auraMap = auraMap;
end

function WindowSettings:GetShowContextMenu()
	return self.menu;
end

function WindowSettings:SetShowContextMenu(flag)
	self.menu = flag;
end


function WindowSettings:GetShowWindow()
	return self.visible;
end

function WindowSettings:SetShowWindow(flag)
	self.visible = flag;
end

function WindowSettings:Copy()

	local copy = WindowSettings();
	copy:SetName(self.name);
	copy:SetLeft(self.left);
	copy:SetTop(self.top);
	copy:SetNumberOfRows(self.nrow);
	copy:SetNumberOfColumns(self.ncol);
	copy:SetPadding(self.padding);
	copy:SetAuraSize(self.size);
	copy:SetBackgroundOpacity(self.opacity);
	copy:SetShowContextMenu(self.menu);
	copy:SetShowWindow(self.visible);
	
	local ii;
	local auraMap = {};
	for ii = 1, table.getn(self.auraMap) do
		auraMap[ii] = self.auraMap[ii];
	end
	copy:SetAuraMap(auraMap);
	
	return copy;

end                    

function WindowSettings:FindAura(index)

	local ret = nil;
	
	local ii;	
	for ii = 1, table.getn(data.auraTable) do
		if (data.auraTable[ii]:GetID() == self.auraMap[index]) then
			ret = data.auraTable[ii];
		end
	end
	
	return ret;

end